//+------------------------------------------------------------------+
//|                                               Romanisti v1.3.mq4 |
//|                                        Copyright  2007, Gotenkz |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Gotenkz"
#property link      ""

/*
Use in pair GBPUSD TF H1

The most important of this EA is Market Hour Setting.

if your broker is in:
1. GMT,   set StartHour = 8,  EndHour = 16.
2. GMT+1, set StartHour = 9,  EndHour = 17.
3. GMT+2, set StartHour = 10, EndHour = 18.

*/

extern int    Trap = 25;

extern string Romanisti_Set1 = "-----Market Hour Setting-----";
extern int    StartHour      = 9;
extern int    EndHour        = 17;

extern string Romanisti_Set2 = "-----Profit Management Setting-----";
extern int    TakeProfit     = 160;
extern int    StopLoss       = 60;
extern int    TrailingStop   = 60;
extern int    SteppingStop   = 30;
extern int    PipsProtect    = 10;

extern string Romanisti_Set3   = "-----Money Management Setting-----";
extern double Lots             = 0.1;
extern bool   MoneyManagement  = true;
extern double TradeSizePercent = 10;
extern double MaxLots          = 5;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   int i,Ticket;
   int Magic = 46035;
   static datetime TradeTime;
   
   if(MoneyManagement)
   {
    double LotsMM = NormalizeDouble(MathFloor(AccountBalance()*TradeSizePercent/1000)/100,1);
    if(LotsMM>MaxLots) LotsMM = MaxLots;
    if(LotsMM<Lots)    LotsMM = Lots;
   }
   else LotsMM = Lots;
   
   if(Hour() == StartHour)
   {
    if(TradeTime != iTime(NULL,PERIOD_D1,0))
    {
     TradeTime = iTime(NULL,PERIOD_D1,0);
     
     double BuyStop  = Open[0]+Trap*Point;
     double SellStop = Open[0]-Trap*Point;
     
     Ticket = OrderSend(Symbol(),OP_BUYSTOP,LotsMM,BuyStop,3,BuyStop-StopLoss*Point,BuyStop+TakeProfit*Point,NULL,Magic,TradeTime+EndHour*60*60,Blue);
     Ticket = OrderSend(Symbol(),OP_SELLSTOP,LotsMM,SellStop,3,SellStop+StopLoss*Point,SellStop-TakeProfit*Point,NULL,Magic,TradeTime+EndHour*60*60,Red);
    }
   }
   
   for(i=0; i<OrdersTotal(); i++)
   {
    if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false)      break;
    if(OrderMagicNumber()!=Magic || OrderSymbol()!=Symbol()) continue;
    
    if(OrderSymbol()==Symbol())
    {  
     if(OrderType()==OP_BUY)
     {
      if(Bid - OrderOpenPrice() > SteppingStop*Point)
      {
       if(OrderStopLoss() < Bid-SteppingStop*Point)
       {
        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+PipsProtect*Point,0,Yellow);
       }
      }
      if(Bid > OrderOpenPrice()+TrailingStop*Point)
      {
       if(OrderStopLoss() < Bid-TrailingStop*Point)
       {
        OrderModify(OrderTicket(),OrderOpenPrice(),Bid-(TrailingStop-PipsProtect)*Point,0,White);
        return(0);
       }
      }
     }
     if(OrderType()==OP_SELL)
     {
      if(OrderOpenPrice()-Ask > SteppingStop*Point)
      {
       if(OrderStopLoss() > Ask+SteppingStop*Point)
       {
        OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-PipsProtect*Point,0,Yellow);
       }
      }
      if(Ask < OrderOpenPrice()-TrailingStop*Point)
      {
       if(OrderStopLoss() > Ask+TrailingStop*Point)
       {
        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+(TrailingStop-PipsProtect)*Point,0,White);
        return(0);
       }
      }
     }
     if(TimeCurrent()>TradeTime+EndHour*60*60)
     {
      if(OrderType() == OP_BUY)  OrderClose(OrderTicket(),OrderLots(),Bid,3,Magenta);
      if(OrderType() == OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,3,Magenta);
     }
    }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+